using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ExampleOnTabControl
{
    public partial class Form1 : Form
    {
        private int currentTabIndex ;
        private bool isInViewMode = false;

        public Form1()
        {
            InitializeComponent();
            this.tabControl1.SelectedIndex = 0;
            this.EditBT.Enabled = false;
        }

        private void SaveBT_Click(object sender, EventArgs e)
        {
            this.SaveBT.Enabled = false;
            isInViewMode = true;
            notesTabPage.TabVisible = false;
            for(int i = 0; i< this.Controls.Count; i++)
            {
                EnableControls(false, this.Controls[i]);
            }
            this.tabControl1.SelectedIndex = 0;
            this.EditBT.Enabled = true;
        }

        private void EditBT_Click(object sender, EventArgs e)
        {
            this.EditBT.Enabled = false;
            isInViewMode = false;
            notesTabPage.TabVisible = true;
            this.tabControl1.ValidateSelectedIndex();
            this.generalTabPage.Refresh();

            for (int i = 0; i < this.Controls.Count; i++)
            {
                EnableControls(true, this.Controls[i]);
            }
            this.tabControl1.SelectedIndex = currentTabIndex;
            this.SaveBT.Enabled = true;
        }

        private void EnableControls(bool enable, Control ctrl)
        {
            if (ctrl.HasChildren)
            {
                for (int i = 0; i < ctrl.Controls.Count; i++)
                {
                    EnableControls(enable, ctrl.Controls[i]);
                }
            }
            if (ctrl is TextBox)
            {
                ctrl.Enabled = enable;
            }
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (isInViewMode)
            {
                currentTabIndex = this.tabControl1.SelectedIndex;
            }
        }
    }
}